package mw;

import java.awt.*;

/**
 * ResourceButton.java
 * extends Button
 * holds a Resource, which will be fired upon the buttons selection
 * @author Michael Bartley
 * 7/17/98
 */

class ResourceButton extends Button{
  private Resource resource;
  
  public ResourceButton(Resource r){
    super();
    resource = r;
    setLabel(resource.getMimeType());
  }

  public void setResource(Resource r){resource = r;}
  public Resource getResource(){return resource;}

  public boolean action(Event e, Object arg){
    if(e.id == Event.ACTION_EVENT){
      resource.display();
      return true;
    }
    return false;
  }
}
