package mw;

import java.net.*;
import java.awt.*;
import java.applet.*;
import java.io.*;

/**
 *
 * NaviKeyApplet.java
 *
 * @author Michael Bartley
 * 3/25/98
 */

public class NaviKeyApplet extends Applet{
    //public static String imageLocation;
    SuperPanel superPanel;
    Label l;
    Panel top;
    TextArea ta;
    DeltaInterface delta;
    ConfigurationPanel cp;
    
    //These will be adjusted by user, and used by all subpanels as selections
    static Color naviKeyBackgroundColor = Color.black;
    static Color itemCharacterColor     = Color.cyan;
    static Color itemStateColor         = Color.magenta;
    static Color itemSelectionsColor    = Color.green;
    static Color itemListColor          = Color.yellow;
    static Color buttonColor            = Color.pink;
    static Color boxBGColor             = Color.white;
    static Color boxFGColor             = Color.black;
    static Color itemDisplayColor       = Color.cyan;
    static Color itemDisplayTextColor   = Color.white;
    static Color itemDisplayBGColor     = Color.darkGray;
    static Color itemDisplayFGColor     = Color.green;
    static Color imageBGColor           = Color.black;
    static Color imageFGColor           = Color.white;
    
    private boolean standAlone;
    private String specsfile=null;
    private String charsfile=null;
    private String itemsfile=null;
    private String imageDirectory=null;
    static boolean intelligence = true;
    
    private String servletURL=null;
    
    private void initializeParameters(){
	DataInputStream dis = null;
	try{
	    String props = getParameter("propsfile");
	    URL url = new URL(getCodeBase().toString() + props);
	    dis = new DataInputStream(url.openStream());
	}
	catch(Exception e){
	    System.out.println("No color scheme specified, using defaults");
	    return;
	}
	
	String line     = new String("");
	String value    = new String("");
	Color colorSelect = null;
	String field    = new String("");
	
	while(line != null){
	    try{
		line = dis.readLine();
		while(line != null){
		    colorSelect = null;
		    if(line.indexOf('=') > 0){
			field = line.substring(0,line.indexOf('='));
			value = line.substring(line.indexOf('=') + 1);
			
			if(field.equals("standalone")){
			    if(value.equals("false")){
				System.out.println("Good luck, servlet");
				standAlone = false;
			    }
			    else{
				System.out.println("Using da files" + field + value);
				standAlone = true;
			    }
			}
			
			else if(field.equals("servletURL")){
			    servletURL = value;
			}
			
			else if(field.equals("specsfile"))
			    specsfile = value;
			else if(field.equals("charsfile"))
			    charsfile = value;
			else if(field.equals("itemsfile"))
			    itemsfile = value;
			else if(field.equals("imageDirectory"))
			    imageDirectory = value;
			
			else{
			    if (value.equals("black"))
				colorSelect = Color.black;
			    else if (value.equals("blue"))
				colorSelect = Color.blue;
			    else if (value.equals("cyan"))
				colorSelect = Color.cyan;
			    else if (value.equals("darkGray"))
				colorSelect = Color.darkGray;
			    else if (value.equals("gray"))
				colorSelect = Color.gray;
			    else if (value.equals("green"))
				colorSelect = Color.green;
			    else if (value.equals("lightGray"))
				colorSelect = Color.lightGray;
			    else if (value.equals("magenta"))
				colorSelect = Color.magenta;
			    else if (value.equals("orange"))
				colorSelect = Color.orange;
			    else if (value.equals("pink"))
				colorSelect = Color.pink;
			    else if (value.equals("red"))
				colorSelect = Color.red;
			    else if (value.equals("white"))
				colorSelect = Color.white;
			    else if (value.equals("yellow"))
				colorSelect = Color.yellow;
			    
			    if(colorSelect != null){
				if(field.equals("naviKeyBackgroundColor"))
				    naviKeyBackgroundColor = colorSelect;
				else if (field.equals("itemCharacterColor"))
				    itemCharacterColor = colorSelect;
				else if (field.equals("itemSelectionsColor"))
				    itemSelectionsColor = colorSelect;
				else if (field.equals("itemListColor"))
				    itemListColor = colorSelect;
				else if (field.equals("buttonColor"))
				    buttonColor = colorSelect;
				else if (field.equals("boxBGColor"))
				    boxBGColor = colorSelect;
				else if (field.equals("boxFGColor"))
				    boxFGColor = colorSelect;
				else if (field.equals("itemDisplayColor"))
				    itemDisplayColor = colorSelect;
				else if (field.equals("itemDisplayTextColor"))
				    itemDisplayTextColor = colorSelect;
				else if (field.equals("itemDisplayBGColor"))
				    itemDisplayBGColor = colorSelect;
				else if (field.equals("itemDisplayFGColor"))
				    itemDisplayFGColor = colorSelect;
				else if (field.equals("imageBGColor"))
				    imageBGColor = colorSelect;
				else if (field.equals("imageFGColor"))
				    imageFGColor = colorSelect;
			    }
			}
		    }
		    line = dis.readLine();
		}
	    }
	    catch(Exception e){
		System.out.println("Some error in reading file, using defaults");
		return;
	    }
	    System.out.println(line);
	}
    }
    
    public NaviKeyApplet(){
    }
    
    public void init(){
	setLayout(new BorderLayout());
	initializeParameters();
	DeltaConnector dc;
	
	if(imageDirectory != null){
	    try{
		Resource.defaultLocation = getCodeBase().toString() + imageDirectory +"/";
	    }
	    catch(Exception e){
		System.out.println("Unable to get code base. "+e);
	    }
	}
	if(standAlone)
	    dc = runStandAlone();
	else
	    dc = runHttpConnector();
	delta = dc.getObject();
	superPanel = new SuperPanel(delta);
	
	System.out.println("Setting panels");
	superPanel.itemCharacterPanel.setItemCharacters(delta.getItemCharacterList(null, false));
	superPanel.itemCharacterPanel.updateList();
	
	superPanel.itemsPanel.setItems(delta.getItemList(null));
	superPanel.itemsPanel.updateList();
	
	System.out.println("Composing all");
	superPanel.build();
	superPanel.statePanel.getTheLayout().first(superPanel.statePanel);
	
	System.out.println("setting layouts");
	cp = new ConfigurationPanel();
	add(cp);
	//add("Center",superPanel);
	add(superPanel);

	System.out.println("Done with init");
    }
    
    private LocalDeltaConnector runStandAlone(){
	if(specsfile == null || charsfile == null || itemsfile == null){
	    System.out.println("Required files not specified.");
	    System.exit(0);
	}
	try{
	    URL base = getCodeBase();
	    String url = base.toString();
	    System.out.println("Printme");
	    return new LocalDeltaConnector(url, specsfile, charsfile, itemsfile);
	}
	catch(Exception e){
	    System.out.println("Error reading delta files.\n" +e);
	    System.exit(0);
	    return new LocalDeltaConnector();
	}
    }
    
    private HttpDeltaConnector runHttpConnector(){
	//return new HttpDeltaConnector("url goes here");
	return new HttpDeltaConnector(servletURL);
    }
    
    public void start(){
	System.out.println(superPanel.bounds());
	superPanel.reshape(0,0,640,480);
	IconPanel ip = null;
	try{
	    ip = new IconPanel(getCodeBase() + "nlogo.gif");
	    //System.out.println("\n"+getCodeBase() + "nlogo.gif");
	}
	catch(Exception e){
	    System.out.println("image file not available" +e);
	}
	superPanel.reshape(0,0,bounds().width, superPanel.bounds().height - (ip.getImageHeight()) - 35);
	cp.reshape(cp.bounds().x, superPanel.bounds().height, bounds().width, 35);
	cp.setBackground(naviKeyBackgroundColor);
	if(naviKeyBackgroundColor.equals(Color.black))
	    cp.setForeground(Color.white);
	else
	    cp.setForeground(Color.black);
	System.out.println(superPanel.bounds());
	ip.adjustPosition(new Point(superPanel.bounds().width/2 - 
				           ip.getImageWidth() / 2, 
				    superPanel.bounds().height + 
				           cp.bounds().height));

	add(ip);
	repaint();
    }
    
}
