package mw;

import java.util.Vector;

/**
 * @author Noel Cross
 * @author Michael Bartley
 */

public class NumericAttribute extends Attribute {
  //NumericState ns;
  //String comment;
  Vector commentedStates;
  public NumericAttribute(){
    super();
    commentedStates = new Vector();
  }

  public void addCommentedState(State s, String str){
    commentedStates.addElement(new CommentedState(s, str));

    /*    try{
      setNumericState((NumericState)s);
      setComment(str);
    }
     catch(Exception e) {
       System.out.println(e);
       }*/
  }

  //public void setNumericState(NumericState ns){this.ns = ns;}
  //public void setComment(String comment){this.comment = comment;}
  //public Vector getNumericStates(){return commentedStates;}
  //public String getComment(){return comment;}
  
  public Vector getCommentedStates(){
    return commentedStates;
    //Vector v = new Vector();
    //CommentedState cs = new CommentedState(ns, comment);
    //v.addElement(cs);
    //return v;
  }
  public Vector getStates(){
    Vector v = new Vector();
    for(int i = 0; i<commentedStates.size(); i++){
      v.addElement(((CommentedState)commentedStates.elementAt(i)).getState());
    }
    return v;
  }

  public boolean containsState(State st){
    boolean b = false;
    Vector v = getStates();
    for(int i = 0; i < v.size(); i++){
      State st2 = (State)v.elementAt(i);
      if(st == st2){
	b = true;
      }
    }
    return b;
  }


  public boolean sameAs(Attribute a){
    boolean noContradiction = false;
    Vector passed = a.getStates();
    Vector v2 = getStates();
  
  outerloop:
    for(int i=0; i<passed.size(); i++){
      noContradiction = false;
      NumericState statePassed = (NumericState)passed.elementAt(i);
      if(statePassed == null){
	continue;
      }
      for(int j=0; j < v2.size(); j++){
	NumericState s2 = (NumericState)v2.elementAt(j);
	if(statePassed != null && s2 != null && 
	   //statePassed must fall within the ranges of s2
	   s2.fallsWithinExtremeRange(statePassed)) {
	  noContradiction = true;
	  break outerloop;
	}
      }
    }
    return noContradiction;
  }

  public void print(){
    System.out.println(toString());
  }
  public String toString(){
    StringBuffer sb = new StringBuffer();
    sb.append("ItemCharacter: " + super.ic.getId() + ". " + super.ic.getFeature());
    for(int i=0; i<commentedStates.size(); i++){
      CommentedState cs = (CommentedState)commentedStates.elementAt(i);
      NumericState ns = (NumericState)cs.getState();
      String comment = cs.getComment();
      if(comment != null){
	sb.append(comment);
      }
      if(ns != null){
	sb.append(ns.toString());
      }
    }
    if(super.comment != null){
      sb.append(super.comment);
    }
    return new String(sb);
  }

  public String shortOutput(){
    StringBuffer sb = new StringBuffer();
    for(int i=0; i<commentedStates.size(); i++){
      if(i > 0){
	sb.append("/");
      }
      CommentedState cs = (CommentedState)commentedStates.elementAt(i);
      NumericState ns = (NumericState)cs.getState();
      String comment = cs.getComment();
      if(comment != null){
	sb.append(comment);
      }
      if(ns != null){
	sb.append(ns.getStringValue());
      }
    }
    if(super.comment != null){
      sb.append(super.comment);
    }
    return new String(sb);
  }

}


