package mw;

/**
 * DeltaFilePeer.java
 * @author Noel Cross
 * @author Michael Bartley
 */

import java.io.*;
//import pnp.persistent.*;

public class DeltaFilePeer implements PersistentPeer{
  private DataInputStream specsStream;
  private DataInputStream charsStream;
  private DataInputStream itemsStream;

  public DeltaFilePeer(DataInputStream specs, DataInputStream chars, DataInputStream items){
    specsStream = specs;
    charsStream = chars;
    itemsStream = items;
  }
  
  public void restore(Persistent p){
    SpecsFileReader sfr = new SpecsFileReader();
    sfr.read(specsStream);
    sfr.makeItemCharacterTypes();
    
    CharsFileReader cfr = new CharsFileReader();
    cfr.setItemCharacterTypes(sfr.getItemCharacterTypes());
    cfr.read(charsStream);
    
    ItemsFileReader ifr = new ItemsFileReader();
    ifr.setItemCharacters(cfr.getItemCharacters());
    ifr.read(itemsStream);
  }

  public void update(Persistent p){
  }

  public void insert(Persistent p){
  }

  public void delete(Persistent p){
  }

}
