
package mw;

import java.awt.*;
import java.util.Vector;

/**

 * ItemStatePanel.java
 *
 * @author Michael Bartley
 * 3/25/98
 */

class ItemStatePanel extends Frame{
  Vector strings;
  Vector resources;
  List theList; // display all multi-state, numeric, and text attributes
  Button close; // kill frame
  Panel bp; // hold all buttons
  Vector resourceButtons;
  Panel resourceButtonPanel;
  private final int MAX_STRING_LENGTH = 80;

  public ItemStatePanel(String title, Vector strings, Vector resources){
    super();
    setTitle(title);
    this.strings = strings;
    this.resources = resources;
    if(strings == null)
      strings = new Vector();
    if(resources == null)
      resources = new Vector();
    setBackground(NaviKeyApplet.itemDisplayBGColor);
    setForeground(NaviKeyApplet.itemDisplayFGColor);
    resourceButtons = new Vector();
    setLayout(new BorderLayout());
    theList = new List(25, false);
    theList.setBackground(NaviKeyApplet.itemDisplayColor);
    theList.setForeground(NaviKeyApplet.itemDisplayTextColor);
    updateList();
    updateResources();
    add("Center",theList);
    resourceButtonPanel = new Panel();
    resourceButtonPanel.setLayout(new FlowLayout());
    for(int i=0; i<resourceButtons.size(); i++){
      resourceButtonPanel.add((ResourceButton)resourceButtons.elementAt(i));
    }
    close = new Button("Close");
    bp = new Panel();
    bp.setLayout(new BorderLayout());
    bp.add("East",close);
    bp.add("West", resourceButtonPanel);
    add("North",bp);
    resize(600,600);
    show();
  }

  public boolean action(Event e, Object o){
    if(e.target == close){
      dispose();
      return true;
    }
    return false;
  }

  public void updateList(){
    for(int i=0; i<strings.size(); i++){
      String s = (String)strings.elementAt(i);
      boolean first = true;
      while(s.length() > MAX_STRING_LENGTH){
	String addition = s.substring(0, MAX_STRING_LENGTH);
	int cut = addition.lastIndexOf(" ");
	if(cut < 0)
	  cut = MAX_STRING_LENGTH;

	addition = addition.substring(0, cut);
	theList.addItem(addition);
	s = "          " + s.substring(cut);
      }
      theList.addItem(s);
    }
  }

    public void updateResources(){
	if(resources != null){
	    for(int i=0; i<resources.size(); i++){
		resourceButtons.addElement(new ResourceButton((Resource)resources.elementAt(i)));
	    }
	}
    }
    
}
