package mw;

import java.awt.*;
import java.util.Vector;

/**
 * MyItemPanel.java
 *
 * @author Michael Bartley
 * 3/25/98
 */

class MyItemPanel extends Panel{
    Vector basicStates;
    List theList;
    Panel buttonPanel;
    Button remove;
    Button reset;
    //Checkbox smarts;
    DeltaInterface delta;
    
    public MyItemPanel(DeltaInterface delta){
	super();
	this.delta = delta;
	setLayout(new BorderLayout());
	basicStates = new Vector();
	theList = new List(15, false);
	theList.setBackground(NaviKeyApplet.naviKeyBackgroundColor);
	theList.setForeground(NaviKeyApplet.itemSelectionsColor);
	
	//smarts  = new Checkbox("Smarts");
	//smarts.setState(true);
	remove  = new Button("Remove Selection");
	reset   = new Button("Remove All");
	remove.setBackground(Color.black);
	remove.setForeground(Color.pink);
	reset.setBackground(Color.black);
	reset.setForeground(Color.pink);    
	
	buttonPanel = new Panel();
	buttonPanel.setLayout(new BorderLayout());
	//buttonPanel.add("West",smarts);
	buttonPanel.add("West", remove);
	buttonPanel.add("East", reset);
	add("Center",theList);
	add("North", buttonPanel);
    }
    
    public Button getRemoveButton(){
	return remove;
    }
    
    public Button getResetButton(){
	return reset;
    }
    
    //public Checkbox getSmartsCheckbox(){
    //return smarts;
    //}
    
    public boolean handleEvent(Event e){
	if(e.id == Event.ACTION_EVENT){
	    if(e.target == remove){
		if(theList.getSelectedIndex() != -1){
		    if(theList.countItems() == 1){
			theList.clear();
			removeAllStates();
		    }
		    else{
			int i = theList.getSelectedIndex();
			theList.delItem(i);
			removeStateAt(i);
		    }
		}
	    }
	    else if(e.target == reset){
		if(theList.countItems() != 0){
		    theList.clear();
		    removeAllStates();
		}
	    }
	}
	repaint();
	return false;
    }
    
    public void updateList(){
	if(theList.countItems() != 0)
	    theList.clear();
	
	for(int i = 0; i < basicStates.size(); i++){
	    BasicState st = (BasicState)basicStates.elementAt(i);
	    BasicItemCharacter bc = delta.getBasicItemCharacter(st.getCharacterId());
	    theList.addItem(bc.getFeature() + ":  " + st.getName());
	}
    }
    
    public Vector getStates(){
	return basicStates;
    }

    public void setStates(Vector basicStates){
	this.basicStates = basicStates;
    }
    
    public void addState(BasicState st){
	basicStates.addElement(st);
    }

    public void removeStateAt(int id){
	basicStates.removeElementAt(id);
    }
    
    public void removeAllStates(){
	basicStates.removeAllElements();
    }
}
