package mw;

import java.awt.*;
import java.util.*;

/**
 * NumericStatePanel.java
 *
 * @author Michael Bartley
 * 3/25/98
 */

class NumericStatePanel extends Panel{
  BasicState toBeReturned;

  TextField singleInput;
  TextField lowerRange;
  TextField upperRange;
  Checkbox single;
  Checkbox range;
  CheckboxGroup cbg;
  Button set;
  
  public NumericStatePanel(){
    super();
    singleInput = new TextField(10);
    singleInput.setBackground(NaviKeyApplet.boxBGColor);
    singleInput.setForeground(NaviKeyApplet.boxFGColor);

    lowerRange  = new TextField(10);
    lowerRange.setBackground(NaviKeyApplet.boxBGColor);
    lowerRange.setForeground(NaviKeyApplet.boxFGColor);
    lowerRange.setEditable(false);

    upperRange  = new TextField(10);
    upperRange.setBackground(NaviKeyApplet.boxBGColor);
    upperRange.setForeground(NaviKeyApplet.boxFGColor);
    upperRange.setEditable(false);

    set = new Button("Add");
    set.setBackground(NaviKeyApplet.naviKeyBackgroundColor);
    set.setForeground(NaviKeyApplet.buttonColor);

    cbg = new CheckboxGroup();
    single = new Checkbox("Single Measurement",cbg,true);
    //single.setBackground(NaviKeyApplet.naviKeyBackgroundColor);
    //single.setForeground(NaviKeyApplet.buttonColor);

    range  = new Checkbox("Measurements fall in the range",cbg,false);
    //range.setBackground(NaviKeyApplet.naviKeyBackgroundColor);
    //range.setForeground(NaviKeyApplet.buttonColor);

    Panel top = new Panel();
    top.add(single);
    top.add(singleInput);
    add(top);
    Label llower = new Label("Between");
    Label lupper = new Label("And");
    Panel bottom = new Panel();
    add(range);
    bottom.add(llower);
    bottom.add(lowerRange);
    bottom.add(lupper);
    bottom.add(upperRange);
    add(bottom);
    add(set);
    show();
  }

  public boolean handleEvent(Event e){
    if(e.id == Event.ACTION_EVENT){
      //handle checkbox alterations
      if(e.target == range){
	singleInput.setText("");
	singleInput.setEditable(false);
	lowerRange.setEditable(true);
	upperRange.setEditable(true);
      }
      if(e.target == single){
	singleInput.setEditable(true);
	lowerRange.setText("");
	lowerRange.setEditable(false);
	upperRange.setText("");
	upperRange.setEditable(false);
      }
      // set button clicked, so update our numeric object so it can be used
      if(e.target == set){
	toBeReturned = new NumericState();
	if(cbg.getCurrent() == single){
	  String temp = singleInput.getText();
	  double d = toDouble(temp);
	  toBeReturned.setName((new Double(d)).toString());
	}
	if(cbg.getCurrent() == range){
	  String temp = lowerRange.getText();
	  double dl = toDouble(temp);
	  temp = upperRange.getText();
	  double du = toDouble(temp);
	  toBeReturned.setName(dl+"-"+du);
	}
      }
    }
    return false;
  }

  public Button getAdd(){
    return set;
  }

  public BasicState getState(){
    return toBeReturned;
  }

  public double toDouble(String temp){
    double d;
    try{
      d = Double.valueOf(temp).doubleValue();
    }
    catch(NumberFormatException e){
      d = 0;
    }
    return d;
  }

  public void reset(){
    singleInput.setText("");
    lowerRange.setText("");
    upperRange.setText("");
  }

  public String getInput(){
    return singleInput.getText();
  }
}
